% an efficient implementation of bbnnls
function x=fastbbnnls(a, G, theta, gamma, x0, numiter)
%GG = a*G'*G; 
Gthgm = a*G'*theta + gamma*ones(numel(x0),1);
x = x0;
oldg = a*G'*(G*x) + Gthgm;
aGt = a*G';
grad = oldg; 
for i=1:numiter    
    oldg((x==0) & (grad>0)) = 0;    
    s =G*oldg;
    step = (oldg'*oldg)/(a*s'*s + eps);
    oldx = x;
    x = x - step*grad;
    oldg = grad; 
    x(x<0) = 0;
    
    P = G*x;
    grad = aGt*P + Gthgm;
    %obj = 0.5*a*x'*GG*x + a*theta'*G*x + gamma*sum(x);
    %fprintf('%d) norm(x-oldx)/norm(oldx)+eps) = %f norm(grad,inf)=%f\n', i, norm(x-oldx)/(norm(oldx)+eps), norm(grad,inf));
    if (norm(x-oldx)/(norm(oldx)+eps)< 1e-5 || norm(grad, inf) < 1e-3)
        break;
    end
end

end
